#include <windows.h>
#include <scrnsave.h>
#include <stdlib.h>
#include <time.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include "resource.h"


#define ID_TIMER 32767

void EnableOpenGL(HWND, HDC *, HGLRC *);
void DisableOpenGL(HWND, HDC, HGLRC);

typedef struct{
  unsigned char *tex_img;
  GLuint tex_id;
  GLuint tex_list;
}TEXTURE;


TEXTURE tex1,tex2;


void object_init(void)
{

  int i;

  /* ʐ^ */
  tex1.tex_list = glGenLists(1);
  glNewList(tex1.tex_list, GL_COMPILE);
  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, tex1.tex_id);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0, 0.0); glVertex2f(-2.0,-1.0);
  glTexCoord2f(0.0, 1.0); glVertex2f(-2.0, 1.0);
  glTexCoord2f(1.0, 1.0); glVertex2f( 2.0, 1.0);
  glTexCoord2f(1.0, 0.0); glVertex2f( 2.0,-1.0);
  glEnd();
  glDisable(GL_TEXTURE_2D);
  glEndList();

  /*  */
  tex2.tex_list = glGenLists(11);
  for(i=0;i<10;i++){
	  glNewList(tex2.tex_list+i, GL_COMPILE);
	  glEnable(GL_TEXTURE_2D);
	  glEnable(GL_BLEND);
	  glBindTexture(GL_TEXTURE_2D, tex2.tex_id);
	  glBegin(GL_QUADS);
	  glTexCoord2f((float)i*40.0/512.0, 0.0); glVertex2f(-0.25,-0.4);
	  glTexCoord2f((float)i*40.0/512.0, 1.0); glVertex2f(-0.25, 0.4);
	  glTexCoord2f((float)(i+1)*40.0/512.0, 1.0); glVertex2f( 0.25, 0.4);
	  glTexCoord2f((float)(i+1)*40.0/512.0, 0.0); glVertex2f( 0.25,-0.4);
      glEnd();
	  glDisable(GL_TEXTURE_2D);
	  glDisable(GL_BLEND);
	  glEndList();
  }
  /* R */
	  glNewList(tex2.tex_list+10, GL_COMPILE);
	  glEnable(GL_TEXTURE_2D);
	  glEnable(GL_BLEND);
	  glBindTexture(GL_TEXTURE_2D, tex2.tex_id);
	  glBegin(GL_QUADS);
	  glTexCoord2f((float)400/512, 0.0); glVertex3f(-0.125,-0.4, 0.0);
	  glTexCoord2f((float)400/512, 1.0); glVertex3f(-0.125, 0.4, 0.0);
	  glTexCoord2f((float)420/512, 1.0); glVertex3f( 0.125, 0.4, 0.0);
	  glTexCoord2f((float)420/512, 0.0); glVertex3f( 0.125,-0.4, 0.0);
      glEnd();
	  glDisable(GL_TEXTURE_2D);
	  glDisable(GL_BLEND);
	  glEndList();
}


void display(int wx, int wy)
{
  SYSTEMTIME systemtime;
  static float pos[2]={0.0f, 0.0f};
  static float move[2]={0.02f, 0.02f};
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glLoadIdentity();

  if(rand()%30==0){
    move[0]=-move[1];
  }
  if(rand()%30==1){
    move[1]=move[0];
  }

  /* t[AEg */
  if(pos[0]+move[0]>5.0*wx/wy-2.0 || pos[0]+move[0]<-(5.0*wx/wy-2.0)){
    move[0]=-move[0];
  }
  if(pos[1]+move[1]>4.0 || pos[1]+move[1]<-3.0){
    move[1]=-move[1];
  }
  pos[0]+=move[0];
  pos[1]+=move[1];

  glPushMatrix();
  glTranslatef(pos[0],pos[1],0);
  glCallList(tex1.tex_list);

  GetLocalTime(&systemtime);
  glTranslatef(-1.50, -1.4, 0.00);
  glCallList(tex2.tex_list+(systemtime.wHour/10));
  glTranslatef(0.5,0.0,0.0);
  glCallList(tex2.tex_list+(systemtime.wHour%10));
  glTranslatef(0.375,0.0,0.0);
  glCallList(tex2.tex_list+10);
  glTranslatef(0.375,0.0,0.0);
  glCallList(tex2.tex_list+(systemtime.wMinute/10));
  glTranslatef(0.5,0.0,0.0);
  glCallList(tex2.tex_list+(systemtime.wMinute%10));
  glTranslatef(0.375,0.0,0.0);
  glCallList(tex2.tex_list+10);
  glTranslatef(0.375,0.0,0.0);
  glCallList(tex2.tex_list+(systemtime.wSecond/10));
  glTranslatef(0.5,0.0,0.0);
  glCallList(tex2.tex_list+(systemtime.wSecond%10));

  glPopMatrix();
}


LRESULT WINAPI ScreenSaverProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  RECT rc;
  static int wx, wy;
  static HDC hDC;
  static HGLRC hRC;
  switch(msg) {

  case WM_CREATE:
    EnableOpenGL(hWnd, &hDC, &hRC );
    GetClientRect(hWnd, &rc);
    wx = rc.right - rc.left;
    wy = rc.bottom - rc.top;

    /* OpenGL֘Ȁ(NC1xĂ΂Ȃ) */
    srand((unsigned)time(NULL));

    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glShadeModel (GL_FLAT);
	glGenTextures(1,&tex1.tex_id); 

    glBindTexture(GL_TEXTURE_2D, tex1.tex_id);
	tex1.tex_img=(unsigned char *)LockResource(
      LoadResource( ((LPCREATESTRUCT)(lParam))->hInstance ,
                    FindResource(((LPCREATESTRUCT)(lParam))->hInstance,
                                 IDR_TGA1, TEXT("TGA")  )));

	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
//	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST );
//	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST );
    glTexImage2D(GL_TEXTURE_2D, 0, 3, 512, 256, 0, GL_BGR_EXT, GL_UNSIGNED_BYTE,
                 (tex1.tex_img)+18);
	free(tex1.tex_img);

	glGenTextures(1,&tex2.tex_id); 
	glBindTexture(GL_TEXTURE_2D, tex2.tex_id);
	tex2.tex_img=(unsigned char *)LockResource(
      LoadResource( ((LPCREATESTRUCT)(lParam))->hInstance ,
                    FindResource(((LPCREATESTRUCT)(lParam))->hInstance,
                                 IDR_TGA2, TEXT("TGA")  )));
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);	//	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST );
    glTexImage2D(GL_TEXTURE_2D, 0, 4, 512, 64, 0, GL_BGRA_EXT, GL_UNSIGNED_BYTE,
                 (tex2.tex_img)+18);	
	free(tex2.tex_img);

	object_init();

	glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(-5.0*wx/wy, 5.0*wx/wy, -5.0, 5.0, -5.0, 5.0);
    glMatrixMode(GL_MODELVIEW);
    glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
    glViewport(0,0,wx,wy);
    /* ܂ */

    SetTimer(hWnd, ID_TIMER, 1000, NULL);//^C}[ݒ
    break;
  case WM_TIMER:
    display(wx, wy);
    SwapBuffers( hDC );
	break;
  case WM_ERASEBKGND:
    return TRUE;
  case WM_DESTROY:
	  glDeleteTextures(1,&tex1.tex_id);
	  glDeleteTextures(1,&tex2.tex_id);
    KillTimer(hWnd, ID_TIMER);
    DisableOpenGL( hWnd, hDC, hRC );
    PostQuitMessage(0);
    return 0;
  default:
    break;
  }
  return DefScreenSaverProc(hWnd, msg, wParam, lParam);
}

BOOL WINAPI ScreenSaverConfigureDialog(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
  return TRUE;
}

BOOL WINAPI RegisterDialogClasses(HANDLE hInst)
{
  return TRUE;
}

void EnableOpenGL(HWND hWnd, HDC *hDC, HGLRC *hRC)
{
  int format;
  PIXELFORMATDESCRIPTOR pfd = {
    sizeof(PIXELFORMATDESCRIPTOR),   // size of this pfd
    1,                     // version number
    PFD_DRAW_TO_WINDOW |   // support window
      PFD_SUPPORT_OPENGL |   // support OpenGL
        PFD_DOUBLEBUFFER,      // double buffered
    PFD_TYPE_RGBA,         // RGBA type
    32,                    // 32-bit color depth
    0, 0, 0, 0, 0, 0,      // color bits ignored
    0,                     // no alpha buffer
    0,                     // shift bit ignored
    0,                     // no accumulation buffer
    0, 0, 0, 0,            // accum bits ignored
    24,                    // 32-bit z-buffer
    0,                     // no stencil buffer
    0,                     // no auxiliary buffer
    PFD_MAIN_PLANE,        // main layer
    0,                     // reserved
    0, 0, 0                // layer masks ignored
    };

  *hDC = GetDC(hWnd);
  format = ChoosePixelFormat(*hDC, &pfd);
  SetPixelFormat(*hDC, format, &pfd);

  *hRC = wglCreateContext(*hDC);
  wglMakeCurrent(*hDC, *hRC);
}


void DisableOpenGL(HWND hWnd, HDC hDC, HGLRC hRC)
{
  wglMakeCurrent(NULL, NULL);
  wglDeleteContext(hRC);
  ReleaseDC(hWnd, hDC);
}

